#include <stdio.h>
#include <stdlib.h>
#include "q.h"

int proc_obj(struct q_entry *msg){
        printf("Retrieved Object with Priority: %ld and Text: %s\n", \
			msg->mtype, msg->mtext);
        }

int myserve(void){
	int mlen, r_qid;
	struct q_entry r_entry;

	if ( (r_qid=init_queue()) == -1) 
		return(-1);
	else 	printf("Accessing Queue with ID: %d\n",r_qid);

	for(;;){
		if ( (mlen=msgrcv(r_qid, &r_entry, MAXOBN,		
			(-1 * MAXPRIOR) , MSG_NOERROR) ) == -1 ){
			perror("mesgrcv failed"); return(-1);
			}
		else {
			r_entry.mtext[mlen]='\0';
			proc_obj(&r_entry);
			}
		}
}


main(){
	pid_t pid;
	
	switch (pid=fork()){
	case 0:	// child
		myserve();
		break;
	case -1:
		printf("fork to start the server failed");
		break;
	default:
		printf("server process pid is %d \n", pid);
	}
exit(pid != 1 ? 0 : 1);
}
